####################
# version 2.0
####################



################################################################################
#                                                                              #
# NAME IO.logger  
# DESC Simple Logger
#                                                                              #
################################################################################
"""
:NAME:
IO.Logger

:DESC:
Simple Logger

"""
# IMPORTS
#-------------------------------------------------------------------------------
import sys
import time
#-------------------------------------------------------------------------------
# IMPORTS


# CODE
#-------------------------------------------------------------------------------
class Logger:
    """Simple Logger
    Example:
    l = Logger(open('log', 'w'))
    l.write('hello')
    """
    def __init__(self, out=None):
        """
        out -- file (default= use sys.stdout)
        """
        out = out or sys.stdout
        self.out = out

    def __msg(self, msg):
        self.out.write("[%s] %s\n" %  (time.asctime(), msg))
        self.out.flush()    

    def write(self, msg):
        """Write msg to log
        msg -- string message to write
        """
        self.__msg(msg)
#-------------------------------------------------------------------------------
# CODE

