####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME Sys.timer
# DESC Time utilities
#                                                                              #
################################################################################
"""
:NAME:
Sys.timer

:DESC:
Time utilities

"""
# IMPORTS
#-------------------------------------------------------------------------------
import time
#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------
class Timer:
    def __init__(self):
        self.start    = time.time()
        self.duration = 0.0
        self.stopped  = False
        
    def stop(self):
        if not self.stopped:
            self.duration = time.time() - self.start
            self.stopped = True

    def get_value(self):
        return time.time() - self.start    

    def __repr__(self):
        self.duration = time.time() - self.start
        gm = time.gmtime(self.duration)
        gms = time.strftime('%Hh%Mm%Ss', gm)
        return '%.3fs (%s)' % (self.duration, gms)

#-------------------------------------------------------------------------------
# CODE
