####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME Types.array
# DESC 2D Array Objects
#                                                                              #
################################################################################
"""
:NAME:
Types.array

:DESC:
2D Array Objects

"""
# IMPORTS
#-------------------------------------------------------------------------------
import types
#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------
class Array(object):
    """
    2D array
    example:
    a = Array([[1,2], [3,4]])
    print a[:,1]
    > [2,4]
    
    """

    def __init__(self, l):
        """
        l -- list of list
        """
        self.l = l

    def __getitem__(self, key):
        i,j = key
        if type(i) == int and type(j) == int:
            return self.l[i][j]
        if type(i) == int and type(j) == types.SliceType:
            return self.l[i][j.start or 0:j.stop or len(self.l[i])]
        if type(i) == types.SliceType and type(j) == int:
            return [l[j] for l in self.l[i.start or 0:i.stop or len(self.l)]]   
        if type(i) == types.SliceType and type(j) == types.SliceType:
            return [l[j.start or 0:j.stop or len(l)] for l in self.l[i.start or 0:i.stop or len(self.l)]]
            
        raise IndexError
        
    def __setitem__(self, key, value):
        i,j = key
        if type(i) == int and type(j) == int:
            self.l[i][j] = value
        if type(i) == int and type(j) == types.SliceType:
            self.l[i][j.start or 0:j.stop or len(self.l[i])] = value
        if type(i) == types.SliceType and type(j) == int:
            k = 0
            for l in self.l[i.start or 0:i.stop or len(self.l)]:
                l[j] = value[k]
                k += 1
        if type(i) == types.SliceType and type(j) == types.SliceType:
            k = 0
            for l in self.l[i.start or 0:i.stop or len(self.l)]:
                l[j.start or 0:j.stop or len(l)] = value[k]
                k += 1

    def dim(self, axis=-1):
        if axis == -1:
            return (len(self.l),len(self.l[0]))
        elif axis == 0:
            return len(self.l)
        elif axis == 1:
            return len(self.l[0])

    def append_row(self, row):
        self.l.append(row)
    
    def append_column(self, col):
        for i in range(len(col)):
            self.l[i].append(col[i])

    def __repr__(self):
        return self.l.__repr__()

#-------------------------------------------------------------------------------
# CODE
