####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME Core.Types.string
# DESC String manipulation utilities
#                                                                              #
################################################################################
"""
:NAME:
Core.Types.string

:DESC:
String manipulation utilities

"""
# IMPORTS
#-------------------------------------------------------------------------------
import os.path
import re

#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------

def cmp(a, b):
    if a < b:
        return -1
    if a > b:
        return 1
    return 0


def suffix(filename):
    return filename.split('.')[-1]

def prefix(filename):
    #filename = os.path.basename(filename)
    return filename[:filename.rfind('.')]
    #return filename.split('.')[:-1]

def convert2attr(string):
    attr = string.replace(' ', '_')
    return attr
    
def find(pattern, string):
    """Find first pattern in string
    pattern -- regex pattern or compile regex to find
    string  -- where to search
    return 
        succes: string correponding to matched group or tuple of string if > 1 group
        failure: ''
    Example:
    find(r'(\w+) (\d)', 'aa 2'))
    will return ('aa', '2')
    """
    if type(pattern) == str:
        r = re.search(pattern, string)
    else:
        r = pattern.search(string)
    if r:
        g = r.groups()
        if len(g) == 0:
            return r.group(0)
        elif len(g) == 1:
            return g[0]
        else:
            return g
    else:
        return ''    
    
#-------------------------------------------------------------------------------
# CODE
