####################
# version 2.0
####################


"""
Methods for P-value evaluation

methods: 
    pvalue
    evalue
"""

from numpy import *

import Stats.utils
import Stats.dist

import tab

def pvalue(T_k, T_alpha_b, i, j):
    """
    T_k       -- k Tab per categories dim=(category,pos)
    T_alpha_b -- alpha_b Tab per categories dim=(category,pos)
    """
    
    k     = int( sum(sum(T_k[:,i:j+1])) )
    alpha = float( sum(sum(T_alpha_b[:,i:j+1])) )

    return Stats.dist.ppois(k, alpha)

def evalue(scannedLocation, winMinSize, winMaxSize, pvalue, numberOfScannedMatrices):
    """
    not used
    """
    #L^2 - Lw - (L+1)L/2
    # L(1/2L-w-1/2)

    L = scannedLocation[1] - scannedLocation[0] + 1
    a = winMinSize
    b = winMaxSize
    #N = (L-b)*(b-a) + (b-a)*(b-a)-(b-a+1)*(b-a)/2.
    
    N = (L-a)*float(a)

    return pvalue * numberOfScannedMatrices * N
